diff --git a/tools/FxTestRunner/src/client/test/runner/TestScript.java b/tools/FxTestRunner/src/client/test/runner/TestScript.java
--- a/tools/FxTestRunner/src/client/test/runner/TestScript.java
+++ b/tools/FxTestRunner/src/client/test/runner/TestScript.java
@@ -49,6 +49,10 @@
 import java.net.Socket;
 import java.net.URL;
 import java.net.UnknownHostException;
+import java.util.ArrayList;
+import java.util.HashSet;
+import java.util.List;
+import java.util.Set;
 import java.util.concurrent.Semaphore;
 import java.util.concurrent.TimeUnit;
 import java.util.logging.Level;
@@ -334,13 +338,26 @@
 
         String[] jvmVmOptions = savedEnv.lookup(BasicFXInterview.VM_OPTIONS_PARAM_NAME);
 
+        String[] xPatch = savedEnv.lookup(BasicFXInterview.XPATCH_PARAM_NAME);
+        String xPatchArg = "";
+        if (xPatch != null && xPatch.length > 0) {
+            File xPatchFile = new File(xPatch[0]);
+            xPatchArg = xPatchFile.getAbsolutePath();
+        }
+
+        boolean enableAddExports = YesNoQuestion.YES.equals(lookup(
+                BasicFXInterview.ENABLE_ADD_EXPORTS_PARAM_NAME, YesNoQuestion.NO));
+
+        String noAddExportsArg = enableAddExports ? null : "-DnoAddExports=true";
+
+        String addExportsArg[] = enableAddExports
+                ? combineAddExports(
+                    savedEnv.lookup(BasicFXInterview.ADD_EXPORTS_PARAM_NAME),
+                    td.getParameter(RunUITestFinder.ADD_EXPORTS))
+                : null;
+
         String jvmArgPrismOrder = getJvmArgPrismOrder();
 
-        //TODO (SG): is this still required?
-        String jvmArgLibraryPath = "";
-        if (fxSdkHome != null) {
-            jvmArgLibraryPath = "-Djava.library.path=" + fxSdkHome + File.separator + "rt";
-        }
 
 //        String externaloutput = lookup(BasicFXInterview.EXTERNALOUTPUT, "");
 //        if (externaloutput != null) {
@@ -374,7 +391,7 @@
 
         String swtTestOpt = "";
         try {
-            if (System.getProperty("os.name").toLowerCase().indexOf("mac") >= 0) {
+            if (System.getProperty("os.name").toLowerCase().contains("mac")) {
                 RunWith wunWithAnnotation = Class.forName(testClassName).getAnnotation(RunWith.class);
                 if ((wunWithAnnotation != null) && (wunWithAnnotation.value().equals(CanvasRunner.class))) {
                     swtTestOpt = "-XstartOnFirstThread";
@@ -390,9 +407,17 @@
         String[] command = new String[]{};
         command = addToArray(command, javaExec.trim());
         command = addToArray(command, jvmVmOptions);
+        if (addExportsArg != null) {
+            command = addToArray(command, addExportsArg);
+        } else if (noAddExportsArg != null) {
+            command = addToArray(command, noAddExportsArg);
+        }
+        if (xPatchArg != null && !xPatchArg.isEmpty()) {
+            command = addToArray(command, "--patch-module " + xPatchArg);
+        }
         command = addToArray(command, lookAndFeelOptions);
         command = addToArray(command, ipV4);
-        command = addToArray(command, jvmArgPrismOrder, jvmArgLibraryPath, jvmArgImageUtils);
+        command = addToArray(command, jvmArgPrismOrder, jvmArgImageUtils);
         command = addToArray(command, additionalOptions);
         command = addToArray(command, jvmArgNoDesc, jvmProxyHost, jvmProxyPort, jvmInterop, swtTestOpt);
         command = addToArray(command, jvmArgClientTestRoot);
@@ -403,6 +428,35 @@
         return command;
     }
 
+    static String[] combineAddExports(String[] addExportsArray, String addExportsValue) {
+        if (addExportsValue == null) {
+            return combineAddExports(addExportsArray);
+        } else {
+            String[] newArray = new String[addExportsArray.length + 1];
+            System.arraycopy(addExportsArray, 0, newArray, 1, addExportsArray.length);
+            newArray[0] = addExportsValue;
+            return combineAddExports(newArray);
+        }
+    }
+
+    static String[] combineAddExports(String[] addExportsArray) {
+        List<String> addExportsList = new ArrayList<>();
+        for (String addExports : addExportsArray) {
+            if (addExports != null) {
+                for (String value : addExports.split("\\s*,\\s*")) {
+                    if (!value.isEmpty() && !addExportsList.contains(value.trim())) {
+                        addExportsList.add("--add-exports");
+                        addExportsList.add(value.trim());
+                        addExportsList.add("--add-opens");
+                        addExportsList.add(value.trim());
+                    }
+                }
+            }
+        }
+        return addExportsList.toArray(new String[addExportsList.size()]);
+    }
+
+
     /**
      *
      * @param td
diff --git a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/ByID.java b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/ByID.java
--- a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/ByID.java
+++ b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/ByID.java
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2009, 2012, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2009, 2016, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
@@ -73,4 +73,11 @@
 
         }.dispatch(Environment.getEnvironment());
     }
+
+    @Override
+    public String toString() {
+        return "id is " + super.toString();
+        // TODO: Get access to text and uncomment proper code:
+//        return "Id = " + text;
 }
+}
diff --git a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/Lookups.java b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/Lookups.java
--- a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/Lookups.java
+++ b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/Lookups.java
@@ -60,7 +60,7 @@
      */
     @SuppressWarnings("unchecked")
     public static <T extends Node> Wrap<? extends T> byID(Wrap<?> parent, String id, Class<T> type) {
-        return byID(parent.as(Parent.class, Node.class), id, type);
+        return byID((Parent<Node>) parent.as(Parent.class, Node.class), id, type);
     }
     /**
      * Equivalent to <code>parent.lookup(type, new ByText<T>(text)).wrap(0)</code>
@@ -84,7 +84,7 @@
      */
     @SuppressWarnings("unchecked")
     public static <T extends Node> Wrap<? extends T> byText(Wrap<?> parent, String id, Class<T> type) {
-        return byText(parent.as(Parent.class, Node.class), id, type);
+        return byText((Parent<Node>) parent.as(Parent.class, Node.class), id, type);
     }
     /**
      * Equivalent to <code>FXRoot.ROOT.lookup(new ByTitleSceneLookup<Scene>(title)).wrap(0).as(Parent.class, Node.class)</code>
diff --git a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/QueueExecutor.java b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/QueueExecutor.java
--- a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/QueueExecutor.java
+++ b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/QueueExecutor.java
@@ -222,7 +222,7 @@
         }
 
         public boolean failed() {
-            return action.failed();
+            return !done || action.failed();
         }
 
         public Throwable getThrowable() {
@@ -231,8 +231,9 @@
 
         public synchronized void waitDone(Timeout timeout) {
             try {
-                while (!done) {
-                    wait(timeout.getValue());
+                long maxTime = System.currentTimeMillis() + timeout.getValue();
+                while (!done && System.currentTimeMillis() < maxTime) {
+                    wait(maxTime - System.currentTimeMillis());
                 }
             } catch (InterruptedException ex) {
             }
diff --git a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/SceneList.java b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/SceneList.java
--- a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/SceneList.java
+++ b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/SceneList.java
@@ -47,9 +47,8 @@
             @Override
             public void run(Object... parameters) {
                 LinkedList<Scene> res = new LinkedList<Scene>();
-                Iterator<Window> windows = Window.impl_getWindows();
-                while(windows.hasNext()) {
-                    res.add(windows.next().getScene());
+                for (Window w : Window.getWindows()) {
+                    res.add(w.getScene());
                 }
                 setResult(res);
             }
diff --git a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/WindowList.java b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/WindowList.java
--- a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/WindowList.java
+++ b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/WindowList.java
@@ -47,10 +47,7 @@
             @Override
             public void run(Object... parameters) {
                 LinkedList<Window> res = new LinkedList<Window>();
-                Iterator<Window> windows = Window.impl_getWindows();
-                while(windows.hasNext()) {
-                    res.add(windows.next());
-                }
+                res.addAll(Window.getWindows());
                 setResult(res);
             }
         };
diff --git a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/ContextMenuWrap.java b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/ContextMenuWrap.java
--- a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/ContextMenuWrap.java
+++ b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/ContextMenuWrap.java
@@ -83,7 +83,7 @@
     @As(MenuItem.class)
     public StringMenuOwner<MenuItem> asMenuOwner() {
         if (menuOwner == null) {
-            menuOwner = new StringMenuOwnerImpl(this, this.as(Parent.class, Menu.class));
+            menuOwner = new StringMenuOwnerImpl(this, (Parent <Menu>)this.as(Parent.class, Menu.class));
         }
         return menuOwner;
     }
diff --git a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/ListItemWrap.java b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/ListItemWrap.java
--- a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/ListItemWrap.java
+++ b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/ListItemWrap.java
@@ -117,12 +117,12 @@
     public void show() {
         final List<DATA> items = listViewWrap.getItems();
 
-        AbstractScroll scroll1 = Utils.getContainerScroll(listViewWrap.as(Parent.class, Node.class), listViewWrap.getControl().getOrientation() == Orientation.VERTICAL);
+        AbstractScroll scroll1 = Utils.getContainerScroll((Parent <Node>)listViewWrap.as(Parent.class, Node.class), listViewWrap.getControl().getOrientation() == Orientation.VERTICAL);
         if (scroll1 != null) {
             TableUtils.scrollToInSingleDimension((Wrap<? extends Control>) viewWrap, ListCell.class, p -> items.indexOf(p.getItem()), listViewWrap.getItems().indexOf(getControl()),
             scroll1.caret(), listViewWrap.vertical());
         }
-        AbstractScroll scroll2 = Utils.getContainerScroll(listViewWrap.as(Parent.class, Node.class), listViewWrap.getControl().getOrientation() != Orientation.VERTICAL);
+        AbstractScroll scroll2 = Utils.getContainerScroll((Parent <Node>)listViewWrap.as(Parent.class, Node.class), listViewWrap.getControl().getOrientation() != Orientation.VERTICAL);
         Utils.makeCenterVisible(getClippedContainerWrap(), this, scroll2);
 
     }
diff --git a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/MenuBarWrap.java b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/MenuBarWrap.java
--- a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/MenuBarWrap.java
+++ b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/MenuBarWrap.java
@@ -108,7 +108,7 @@
     @As(MenuItem.class)
     public StringMenuOwner<MenuItem> asMenuOwner() {
         if (menuOwner == null) {
-            menuOwner = new StringMenuOwnerImpl(this, this.as(Parent.class, Menu.class));
+            menuOwner = new StringMenuOwnerImpl(this, (Parent <Menu>)this.as(Parent.class, Menu.class));
         }
         return menuOwner;
     }
diff --git a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/MenuButtonWrap.java b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/MenuButtonWrap.java
--- a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/MenuButtonWrap.java
+++ b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/MenuButtonWrap.java
@@ -97,7 +97,7 @@
     @As(MenuItem.class)
     public StringMenuOwner<MenuItem> asMenuOwner() {
         if (menuOwner == null) {
-            menuOwner = new StringMenuOwnerImpl(this, this.as(Parent.class, Menu.class)) {
+            menuOwner = new StringMenuOwnerImpl(this, (Parent <Menu>)this.as(Parent.class, Menu.class)) {
 
                 @Override
                 protected void prepare() {
diff --git a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/MenuWrap.java b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/MenuWrap.java
--- a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/MenuWrap.java
+++ b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/MenuWrap.java
@@ -73,7 +73,7 @@
     @As(MenuItem.class)
     public StringMenuOwner<MenuItem> asMenuOwner() {
         if (menuOwner == null) {
-            menuOwner = new StringMenuOwnerImpl(this, this.as(Parent.class, Menu.class));
+            menuOwner = new StringMenuOwnerImpl(this, (Parent <Menu>)this.as(Parent.class, Menu.class));
         }
         return menuOwner;
     }
diff --git a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/TableUtils.java b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/TableUtils.java
--- a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/TableUtils.java
+++ b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/TableUtils.java
@@ -255,8 +255,8 @@
      * @return
      */
     static Rectangle getActuallyVisibleArea(final Wrap<? extends Control> wrap) {
-        final Rectangle viewArea = getContainerWrap(wrap.as(Parent.class, Node.class)).getScreenBounds();
-        final Rectangle clippedContainerArea = getClippedContainerWrap(wrap.as(Parent.class, Node.class)).getScreenBounds();
+        final Rectangle viewArea = getContainerWrap((Parent <Node>)wrap.as(Parent.class, Node.class)).getScreenBounds();
+        final Rectangle clippedContainerArea = getClippedContainerWrap((Parent <Node>)wrap.as(Parent.class, Node.class)).getScreenBounds();
         return new Rectangle(viewArea.x, viewArea.y, clippedContainerArea.width, clippedContainerArea.height);
     }
 
diff --git a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/TableViewWrap.java b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/TableViewWrap.java
--- a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/TableViewWrap.java
+++ b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/TableViewWrap.java
@@ -24,7 +24,7 @@
  */
 package org.jemmy.fx.control;
 
-import com.sun.javafx.scene.control.skin.VirtualFlow;
+import javafx.scene.control.skin.VirtualFlow;
 import javafx.collections.ObservableList;
 import javafx.scene.control.*;
 import org.jemmy.Point;
diff --git a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/TreeTableViewWrap.java b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/TreeTableViewWrap.java
--- a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/TreeTableViewWrap.java
+++ b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/TreeTableViewWrap.java
@@ -24,7 +24,7 @@
  */
 package org.jemmy.fx.control;
 
-import com.sun.javafx.scene.control.skin.VirtualFlow;
+import javafx.scene.control.skin.VirtualFlow;
 import java.util.ArrayList;
 import java.util.List;
 import javafx.collections.FXCollections;
@@ -582,4 +582,4 @@
         }
         return cellParent;
     }
-}
\ No newline at end of file
+}
diff --git a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/TreeViewWrap.java b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/TreeViewWrap.java
--- a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/TreeViewWrap.java
+++ b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/TreeViewWrap.java
@@ -24,7 +24,7 @@
  */
 package org.jemmy.fx.control;
 
-import com.sun.javafx.scene.control.skin.VirtualFlow;
+import javafx.scene.control.skin.VirtualFlow;
 import javafx.scene.Node;
 import javafx.scene.control.ScrollBar;
 import javafx.scene.control.TreeCell;
@@ -381,4 +381,4 @@
             return TreeViewWrap.this.getEnvironment();
         }
     }
-}
\ No newline at end of file
+}
diff --git a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/caspian/CaspianDriverFactory.java b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/caspian/CaspianDriverFactory.java
--- a/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/caspian/CaspianDriverFactory.java
+++ b/tools/Jemmy/JemmyFX/src/org/jemmy/fx/control/caspian/CaspianDriverFactory.java
@@ -24,8 +24,8 @@
  */
 package org.jemmy.fx.control.caspian;
 
-import com.sun.javafx.scene.control.skin.ScrollBarSkin;
-import com.sun.javafx.scene.control.skin.SliderSkin;
+import javafx.scene.control.skin.ScrollBarSkin;
+import javafx.scene.control.skin.SliderSkin;
 import javafx.scene.Node;
 import javafx.scene.control.*;
 import org.jemmy.action.FutureAction;
diff --git a/tools/SharedTestUtilsOpen/src/test/javaclient/shared/AppLauncher.java b/tools/SharedTestUtilsOpen/src/test/javaclient/shared/AppLauncher.java
--- a/tools/SharedTestUtilsOpen/src/test/javaclient/shared/AppLauncher.java
+++ b/tools/SharedTestUtilsOpen/src/test/javaclient/shared/AppLauncher.java
@@ -55,6 +55,7 @@
             case SWING:
                 instantiateOnSwingQueue(cl, args);
                 break;
+            // https://bugs.openjdk.java.net/browse/JDK-8131888
             case SWT:
                 instantiateOnSWTQueue(cl, args);
                 break;
@@ -105,6 +106,7 @@
         }
     }
 
+    // https://bugs.openjdk.java.net/browse/JDK-8131888
     private static void instantiateOnSWTQueue(final Class<? extends Interoperability> cl, String[] args) {
         try {
             Interoperability obj = cl.newInstance();
@@ -154,10 +156,8 @@
                     }
                     return Boolean.TRUE;
                 } else {
-                    Iterator<Window> it = Stage.impl_getWindows();
-                    while (it.hasNext()) {
-
-                        if (it.next().isShowing()) {
+                    for (Window w : Stage.getWindows()) {
+                        if (w.isShowing()) {
                             return Boolean.TRUE;
                         }
                     }
diff --git a/tools/SharedTestUtilsOpen/src/test/javaclient/shared/CombinedTestChooserPresenter.java b/tools/SharedTestUtilsOpen/src/test/javaclient/shared/CombinedTestChooserPresenter.java
--- a/tools/SharedTestUtilsOpen/src/test/javaclient/shared/CombinedTestChooserPresenter.java
+++ b/tools/SharedTestUtilsOpen/src/test/javaclient/shared/CombinedTestChooserPresenter.java
@@ -39,6 +39,7 @@
 import javafx.scene.layout.VBox;
 import javafx.scene.paint.Color;
 import org.eclipse.swt.widgets.Shell;
+import com.sun.javafx.stage.WindowHelper;
 
 /**
  *
@@ -183,7 +184,8 @@
         stage.setScene(scene);
         stage.show();
         stage.toFront();
-        stage.setFocused(true);
+        //stage.setFocused(true);
+        WindowHelper.setFocused(stage, true);
     }
 
     public void show(final Object frame, final Object panel) {
diff --git a/tools/SharedTestUtilsOpen/src/test/javaclient/shared/CombinedTestChooserPresenter3D.java b/tools/SharedTestUtilsOpen/src/test/javaclient/shared/CombinedTestChooserPresenter3D.java
--- a/tools/SharedTestUtilsOpen/src/test/javaclient/shared/CombinedTestChooserPresenter3D.java
+++ b/tools/SharedTestUtilsOpen/src/test/javaclient/shared/CombinedTestChooserPresenter3D.java
@@ -28,6 +28,7 @@
 import javafx.scene.layout.Pane;
 import javafx.scene.Group;
 import javafx.stage.Stage;
+import com.sun.javafx.stage.WindowHelper;
 
 /**
  *
@@ -67,7 +68,8 @@
         stage.show();
         stage.toFront();
         setNodeForScreenshot(null);
-        stage.setFocused(true);
+        //stage.setFocused(true);
+        WindowHelper.setFocused(stage, true);
     }
 
 }
diff --git a/tools/SharedTestUtilsOpen/src/test/javaclient/shared/TestBase.java b/tools/SharedTestUtilsOpen/src/test/javaclient/shared/TestBase.java
--- a/tools/SharedTestUtilsOpen/src/test/javaclient/shared/TestBase.java
+++ b/tools/SharedTestUtilsOpen/src/test/javaclient/shared/TestBase.java
@@ -306,7 +306,8 @@
                         res2Name, diffName);
             } else {
                 Wrap<? extends Node> imViewWrap =
-                        (new NodeDock(getScene().as(Parent.class, Node.class), "ViewOfNodeSnapshot")).wrap();
+                        //(new NodeDock(getScene().as(Parent.class, Node.class), "ViewOfNodeSnapshot")).wrap();
+                        (new NodeDock((Parent<Node>)getScene().as(Parent.class, Node.class), "ViewOfNodeSnapshot")).wrap();
                 //Lookups.byID(scene, "ViewOfNodeSnapshot", ImageView.class);
 
                 imViewWrap.waitImage(getScene().getEnvironment().getImageLoader().load(resName),
diff --git a/tools/SharedTestUtilsOpen/src/test/javaclient/shared/TestBaseBase.java b/tools/SharedTestUtilsOpen/src/test/javaclient/shared/TestBaseBase.java
--- a/tools/SharedTestUtilsOpen/src/test/javaclient/shared/TestBaseBase.java
+++ b/tools/SharedTestUtilsOpen/src/test/javaclient/shared/TestBaseBase.java
@@ -95,7 +95,7 @@
          * new ControlDock because there is no ButtonDock Yet.
          */
         final ControlWrap<? extends Control> label =
-                new ControlDock(scene.as(Parent.class, Node.class), name).wrap();
+                new ControlDock((Parent <Node>)scene.as(Parent.class, Node.class), name).wrap();
         label.mouse().move();
         Utils.deferAction(new Runnable() {
             public void run() {
diff --git a/tools/SharedTestUtilsOpen/src/test/javaclient/shared/TestUtil.java b/tools/SharedTestUtilsOpen/src/test/javaclient/shared/TestUtil.java
--- a/tools/SharedTestUtilsOpen/src/test/javaclient/shared/TestUtil.java
+++ b/tools/SharedTestUtilsOpen/src/test/javaclient/shared/TestUtil.java
@@ -37,6 +37,7 @@
 import org.jemmy.timing.State;
 import test.javaclient.shared.description.TreeNode;
 import test.javaclient.shared.screenshots.GoldenImageManager;
+import com.sun.javafx.stage.WindowHelper;
 
 /**
  * Utility methods
@@ -176,7 +177,8 @@
         scene = Root.ROOT.lookup(new ByWindowType(Stage.class)).lookup(Scene.class).wrap(0);
         Utils.deferAction(new Runnable() {
             public void run() {
-                scene.getControl().getWindow().setFocused(true);
+                //scene.getControl().getWindow().setFocused(true);
+                WindowHelper.setFocused(scene.getControl().getWindow(), true);
             }
         });
 
diff --git a/tools/SharedTestUtilsOpen/src/test/javaclient/shared/screenshots/GoldenImageManager.java b/tools/SharedTestUtilsOpen/src/test/javaclient/shared/screenshots/GoldenImageManager.java
--- a/tools/SharedTestUtilsOpen/src/test/javaclient/shared/screenshots/GoldenImageManager.java
+++ b/tools/SharedTestUtilsOpen/src/test/javaclient/shared/screenshots/GoldenImageManager.java
@@ -44,7 +44,7 @@
     private static final String IMG_FOLDER = "images-svn";
 
     private static File getImagesRoot() throws IOException {
-        return new File("../", IMG_FOLDER).getCanonicalFile();
+        return new File("./", IMG_FOLDER).getCanonicalFile();
     }
 
     private static String getSuiteName() throws IOException {
diff --git a/tools/SharedTestUtilsOpen/src/test/javaclient/shared/screenshots/ScreenshotUtils.java b/tools/SharedTestUtilsOpen/src/test/javaclient/shared/screenshots/ScreenshotUtils.java
--- a/tools/SharedTestUtilsOpen/src/test/javaclient/shared/screenshots/ScreenshotUtils.java
+++ b/tools/SharedTestUtilsOpen/src/test/javaclient/shared/screenshots/ScreenshotUtils.java
@@ -167,7 +167,8 @@
     public static Wrap<? extends Node> getPageContent() {
         Node n = application.getNodeForScreenshot();
         final Wrap<? extends Scene> scene = Root.ROOT.lookup(new ByWindowType(Stage.class)).lookup(Scene.class).wrap(0);
-        return new NodeDock(scene.as(Parent.class, Node.class), n.getId()).wrap();
+        //return new NodeDock(scene.as(Parent.class, Node.class), n.getId()).wrap();
+        return new NodeDock((Parent<Node>)scene.as(Parent.class, Node.class), n.getId()).wrap();
     }
 
     /**
